const DATA: &'static str = include_str!("../data/day1.txt");


fn main() {
    let mut counts = DATA.trim()
        .split("\n\n")
        .map(|lines| {
            lines.split("\n")
                .map(|c| c.parse::<u64>().unwrap())
                .collect::<Vec<_>>()
        })
        .collect::<Vec<_>>();

    counts.sort_by_key(|values| values.iter().sum::<u64>());

    let max_total_cals: u64 = counts.last()
        .unwrap()
        .iter()
        .sum();

    let top3_total_cals: &u64 = &counts[(counts.len() - 3)..]
        .iter()
        .flatten()
        .sum();

    println!("Part 1: {max_total_cals}");
    println!("Part 2: {top3_total_cals}");
}
